/* ***********************************************************
 * This file was automatically generated on 2022-05-11.      *
 *                                                           *
 * C# Bindings Version 2.1.31                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures CO2 concentration in ppm
	/// </summary>
	public class BrickletCO2 : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 262;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "CO2 Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CO2_CONCENTRATION = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_CO2_CONCENTRATION = 8;

		private const int CALLBACK_CO2_CONCENTRATION_REACHED = 9;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletCO2.SetCO2ConcentrationCallbackPeriod"/>. The parameter is the CO2
		///  concentration of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletCO2.CO2ConcentrationCallback"/> callback is only triggered if the CO2 concentration
		///  has changed since the last triggering.
		/// </summary>
		public event CO2ConcentrationEventHandler CO2ConcentrationCallback;
		/// <summary>
		/// </summary>
		public delegate void CO2ConcentrationEventHandler(BrickletCO2 sender, int co2Concentration);

		/// <summary>
		/// </summary>
		public event CO2ConcentrationEventHandler CO2Concentration // for backward compatibility
		{
			add { CO2ConcentrationCallback += value; }
			remove { CO2ConcentrationCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletCO2.SetCO2ConcentrationCallbackThreshold"/> is reached.
		///  The parameter is the CO2 concentration.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletCO2.SetDebouncePeriod"/>.
		/// </summary>
		public event CO2ConcentrationReachedEventHandler CO2ConcentrationReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void CO2ConcentrationReachedEventHandler(BrickletCO2 sender, int co2Concentration);

		/// <summary>
		/// </summary>
		public event CO2ConcentrationReachedEventHandler CO2ConcentrationReached // for backward compatibility
		{
			add { CO2ConcentrationReachedCallback += value; }
			remove { CO2ConcentrationReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletCO2(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_CO2_CONCENTRATION] = new CallbackWrapper(OnCO2ConcentrationCallback);
			callbackWrappers[CALLBACK_CO2_CONCENTRATION_REACHED] = new CallbackWrapper(OnCO2ConcentrationReachedCallback);


			responseExpected[FUNCTION_GET_CO2_CONCENTRATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the measured CO2 concentration.
		///  
		///  If you want to get the CO2 concentration periodically, it is recommended to use
		///  the <see cref="Tinkerforge.BrickletCO2.CO2ConcentrationCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletCO2.SetCO2ConcentrationCallbackPeriod"/>.
		/// </summary>
		public int GetCO2Concentration()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CO2_CONCENTRATION);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletCO2.CO2ConcentrationCallback"/> callback is
		///  triggered periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletCO2.CO2ConcentrationCallback"/> callback is only triggered if the CO2 concentration
		///  has changed since the last triggering.
		/// </summary>
		public void SetCO2ConcentrationCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletCO2.SetCO2ConcentrationCallbackPeriod"/>.
		/// </summary>
		public long GetCO2ConcentrationCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletCO2.CO2ConcentrationReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the CO2 concentration is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the CO2 concentration is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the CO2 concentration is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the CO2 concentration is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetCO2ConcentrationCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletCO2.SetCO2ConcentrationCallbackThreshold"/>.
		/// </summary>
		public void GetCO2ConcentrationCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletCO2.CO2ConcentrationReachedCallback"/>,
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletCO2.SetCO2ConcentrationCallbackThreshold"/>,
		///  
		///  keep being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletCO2.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnCO2ConcentrationCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int co2Concentration = LEConverter.UShortFrom(8, response);
			var handler = CO2ConcentrationCallback;

			if (handler != null)
			{
				handler(this, co2Concentration);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnCO2ConcentrationReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int co2Concentration = LEConverter.UShortFrom(8, response);
			var handler = CO2ConcentrationReachedCallback;

			if (handler != null)
			{
				handler(this, co2Concentration);
			}
		}
	}
}
